diff --git a/src/designer/src/components/formeditor/itemview_propertysheet.cpp b/src/designer/src/components/formeditor/itemview_propertysheet.cpp
index 71adf739..9b11b85b 100644
--- a/src/designer/src/components/formeditor/itemview_propertysheet.cpp
+++ b/src/designer/src/components/formeditor/itemview_propertysheet.cpp
@@ -193,16 +193,44 @@ QHash<QString,QString> ItemViewPropertySheet::propertyNameMap() const
 QVariant ItemViewPropertySheet::property(int index) const
 {
     const FakePropertyMap::const_iterator it = d->m_propertyIdMap.constFind(index);
-    if (it != d->m_propertyIdMap.constEnd())
-        return it.value().m_sheet->property(it.value().m_id);
+
+    if (it != d->m_propertyIdMap.constEnd())  {
+        auto pn  = propertyName(index);
+        auto tv = qobject_cast<const QTableView *>(object());
+        bool verbose = tv && pn.contains(QLatin1String("Visible"));
+        if (verbose)
+            qDebug().noquote() << "ItemViewPropertySheet::property()" << index << pn;
+        QVariant v =  it.value().m_sheet->property(it.value().m_id);
+        if (verbose) {
+            auto hh = tv->horizontalHeader();
+            QString on = object()->objectName();
+            auto id = it.value().m_id;
+            qDebug().noquote().nospace() << "  \"" << on << "\", id=" << id
+               << " maps to \"" << it.value().m_sheet->propertyName(id)
+               << "\", propsheet return=" << v
+               << " QHeaderView::isVisible()=" << hh->isVisible()
+               << " QHeaderView::isVisibleTo(tv)" << hh->isVisibleTo(tv);
+        }
+        return v;
+    }
     return QDesignerPropertySheet::property(index);
 }
 
 void ItemViewPropertySheet::setProperty(int index, const QVariant &value)
 {
+    auto pn  = propertyName(index);
+    bool verbose = pn.contains(QLatin1String("Visible"));
+    if (verbose)
+        qDebug().noquote() << "ItemViewPropertySheet::setProperty()" << index << '"' << pn << '"' << value;
+
     const FakePropertyMap::iterator it = d->m_propertyIdMap.find(index);
     if (it != d->m_propertyIdMap.end()) {
-        it.value().m_sheet->setProperty(it.value().m_id, value);
+        int id = it.value().m_id;
+        if (verbose) {
+            QString on = object()->objectName();
+            qDebug() << "  \"" << on << "id=" << id;
+        }
+        it.value().m_sheet->setProperty(id, value);
     } else {
         QDesignerPropertySheet::setProperty(index, value);
     }
@@ -212,6 +240,8 @@ void ItemViewPropertySheet::setChanged(int index, bool changed)
 {
     const FakePropertyMap::iterator it = d->m_propertyIdMap.find(index);
     if (it != d->m_propertyIdMap.end()) {
+        if (index == 92)
+            qDebug() << __FUNCTION__ << object() << index << changed;
         it.value().m_sheet->setChanged(it.value().m_id, changed);
     } else {
         QDesignerPropertySheet::setChanged(index, changed);
@@ -221,8 +251,12 @@ void ItemViewPropertySheet::setChanged(int index, bool changed)
 bool ItemViewPropertySheet::isChanged(int index) const
 {
     const FakePropertyMap::const_iterator it = d->m_propertyIdMap.constFind(index);
-    if (it != d->m_propertyIdMap.constEnd())
-        return it.value().m_sheet->isChanged(it.value().m_id);
+    if (it != d->m_propertyIdMap.constEnd()) {
+        bool r = it.value().m_sheet->isChanged(it.value().m_id);
+        if (index == 92)
+            qDebug() << __FUNCTION__ << object() << index << r;
+        return r;
+    }
     return QDesignerPropertySheet::isChanged(index);
 }
 
@@ -238,15 +272,20 @@ bool ItemViewPropertySheet::reset(int index)
 {
     const FakePropertyMap::iterator it = d->m_propertyIdMap.find(index);
     if (it != d->m_propertyIdMap.end()) {
+
        QDesignerPropertySheetExtension *headerSheet = it.value().m_sheet;
        const int headerIndex = it.value().m_id;
        const bool resetRC = headerSheet->reset(headerIndex);
+       if (index == 92)
+           qDebug() << __FUNCTION__ << object() << index << resetRC;
        // Resetting for "visible" might fail and the stored default
        // of the Widget database is "false" due to the widget not being
        // visible at the time it was determined. Reset to "true" manually.
        if (!resetRC && headerSheet->propertyName(headerIndex) == QLatin1String(visibleProperty)) {
+           qDebug() << __FUNCTION__ << object() << index << ">Hardcoded reset to true";
            headerSheet->setProperty(headerIndex, QVariant(true));
            headerSheet->setChanged(headerIndex, false);
+           qDebug() << __FUNCTION__ << object() << index << "<Hardcoded reset to true";
            return true;
        }
        return resetRC;
diff --git a/src/designer/src/designer/qdesigner_actions.cpp b/src/designer/src/designer/qdesigner_actions.cpp
index 7b86200f..da28b648 100644
--- a/src/designer/src/designer/qdesigner_actions.cpp
+++ b/src/designer/src/designer/qdesigner_actions.cpp
@@ -806,6 +806,7 @@ bool QDesignerActions::readInForm(const QString &fileName)
 
 bool QDesignerActions::writeOutForm(QDesignerFormWindowInterface *fw, const QString &saveFile, bool check)
 {
+    qDebug(">QDesignerActions::writeOutForm");
     Q_ASSERT(fw && !saveFile.isEmpty());
 
     if (check) {
@@ -869,6 +870,7 @@ bool QDesignerActions::writeOutForm(QDesignerFormWindowInterface *fw, const QStr
 
     fw->setDirty(false);
     fw->parentWidget()->setWindowModified(false);
+    qDebug("<QDesignerActions::writeOutForm");
     return true;
 }
 
diff --git a/src/designer/src/designer/qdesigner_workbench.cpp b/src/designer/src/designer/qdesigner_workbench.cpp
index d18d2a17..a6b80c88 100644
--- a/src/designer/src/designer/qdesigner_workbench.cpp
+++ b/src/designer/src/designer/qdesigner_workbench.cpp
@@ -661,17 +661,23 @@ void QDesignerWorkbench::slotFileDropped(const QString &f)
 
 bool QDesignerWorkbench::readInForm(const QString &fileName) const
 {
+    qDebug(">QDesignerWorkbench::readInForm");
     return m_actionManager->readInForm(fileName);
+    qDebug("<QDesignerWorkbench::readInForm");
 }
 
 bool QDesignerWorkbench::writeOutForm(QDesignerFormWindowInterface *formWindow, const QString &fileName) const
 {
+    qDebug(">QDesignerWorkbench::writeOutForm");
     return m_actionManager->writeOutForm(formWindow, fileName);
+    qDebug("<QDesignerWorkbench::writeOutForm");
 }
 
 bool QDesignerWorkbench::saveForm(QDesignerFormWindowInterface *frm)
 {
+    qDebug(">QDesignerWorkbench::saveForm");
     return m_actionManager->saveForm(frm);
+    qDebug(">QDesignerWorkbench::saveForm");
 }
 
 QDesignerFormWindow *QDesignerWorkbench::findFormWindow(QWidget *widget) const