diff --git a/sources/pyside6/PySide6/glue/qtcore.cpp b/sources/pyside6/PySide6/glue/qtcore.cpp
index 7229fd378..53e2ef864 100644
--- a/sources/pyside6/PySide6/glue/qtcore.cpp
+++ b/sources/pyside6/PySide6/glue/qtcore.cpp
@@ -360,6 +360,7 @@ static bool getReceiver(QObject *source,
                         PyObject **self,
                         QByteArray *callbackSig)
 {
+    qDebug() << __FUNCTION__<< source << signal << receiver << *callbackSig;
     bool forceGlobalReceiver = false;
     if (PyMethod_Check(callback)) {
         *self = PyMethod_GET_SELF(callback);
@@ -385,6 +386,8 @@ static bool getReceiver(QObject *source,
     }
 
     bool usingGlobalReceiver = !*receiver || forceGlobalReceiver;
+    qDebug() << __FUNCTION__<< "usingGlobalReceiver=" << usingGlobalReceiver
+             << "forceGlobalReceiver=" << forceGlobalReceiver;
 
     // Check if this callback is a overwrite of a non-virtual Qt slot.
     if (!usingGlobalReceiver && receiver && self) {
@@ -407,6 +410,9 @@ static bool getReceiver(QObject *source,
         *callbackSig = PySide::Signal::getCallbackSignature(signal, *receiver, callback, usingGlobalReceiver).toLatin1();
     }
 
+    qDebug() << __FUNCTION__<< "rets usingGlobalReceiver=" << usingGlobalReceiver
+             << "receiver=" << *receiver << "self=" << *self
+             << *callbackSig;
     return usingGlobalReceiver;
 }
 
@@ -434,12 +440,14 @@ static QMetaObject::Connection qobjectConnect(QObject *source, QMetaMethod signa
                                               QObject *receiver, QMetaMethod slot,
                                               Qt::ConnectionType type)
 {
+   qDebug() << __FUNCTION__<< source << signal.name() << receiver <<  slot.name();
    return qobjectConnect(source, signal.methodSignature(), receiver, slot.methodSignature(), type);
 }
 
 static QMetaObject::Connection qobjectConnectCallback(QObject *source, const char *signal,
                                                       PyObject *callback, Qt::ConnectionType type)
 {
+    qDebug() << __FUNCTION__<< source << signal;
     if (!signal || !PySide::Signal::checkQtSignal(signal))
         return {};
     signal++;
@@ -455,6 +463,7 @@ static QMetaObject::Connection qobjectConnectCallback(QObject *source, const cha
     PyObject *self = nullptr;
     QByteArray callbackSig;
     bool usingGlobalReceiver = getReceiver(source, signal, callback, &receiver, &self, &callbackSig);
+    qDebug() << __FUNCTION__<< "usingGlobalReceiver=" << usingGlobalReceiver << receiver;
     if (receiver == nullptr && self == nullptr)
         return {};
 
@@ -510,6 +519,7 @@ static bool qobjectDisconnectCallback(QObject *source, const char *signal, PyObj
 {
     if (!PySide::Signal::checkQtSignal(signal))
         return false;
+    qDebug() << __FUNCTION__<< source << signal;
 
     PySide::SignalManager &signalManager = PySide::SignalManager::instance();
 
@@ -519,6 +529,7 @@ static bool qobjectDisconnectCallback(QObject *source, const char *signal, PyObj
     QByteArray callbackSig;
     QMetaMethod slotMethod;
     bool usingGlobalReceiver = getReceiver(nullptr, signal, callback, &receiver, &self, &callbackSig);
+    qDebug() << __FUNCTION__<< "usingGlobalReceiver=" << usingGlobalReceiver << receiver;
     if (receiver == nullptr && self == nullptr)
         return false;
 
@@ -531,6 +542,7 @@ static bool qobjectDisconnectCallback(QObject *source, const char *signal, PyObj
 
     bool disconnected;
     disconnected = QMetaObject::disconnectOne(source, signalIndex, receiver, slotIndex);
+    qDebug() << __FUNCTION__<< "disconnected=" << disconnected;
 
     if (disconnected) {
         if (usingGlobalReceiver)
diff --git a/sources/pyside6/libpyside/globalreceiverv2.cpp b/sources/pyside6/libpyside/globalreceiverv2.cpp
index 601e893f7..31c864885 100644
--- a/sources/pyside6/libpyside/globalreceiverv2.cpp
+++ b/sources/pyside6/libpyside/globalreceiverv2.cpp
@@ -206,6 +206,7 @@ GlobalReceiverV2::GlobalReceiverV2(PyObject *callback, GlobalReceiverV2MapPtr ma
     m_data = new DynamicSlotDataV2(callback, this);
     m_metaObject.addSlot(RECEIVER_DESTROYED_SLOT_NAME);
     m_metaObject.update();
+    qDebug() << Q_FUNC_INFO << "\n    " << this;
     m_refs.append(nullptr);
 
 
@@ -220,6 +221,7 @@ GlobalReceiverV2::GlobalReceiverV2(PyObject *callback, GlobalReceiverV2MapPtr ma
 
 GlobalReceiverV2::~GlobalReceiverV2()
 {
+     qDebug() << Q_FUNC_INFO << "\n    " << this;
     m_refs.clear();
     // Remove itself from map.
     m_sharedMap->remove(m_data->key());
@@ -237,11 +239,13 @@ GlobalReceiverV2::~GlobalReceiverV2()
 
 int GlobalReceiverV2::addSlot(const char *signature)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << this << signature;
     return m_data->addSlot(signature);
 }
 
 void GlobalReceiverV2::incRef(const QObject *link)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " <<  this << link;
     if (link) {
         if (!m_refs.contains(link)) {
             bool connected{};
@@ -258,10 +262,12 @@ void GlobalReceiverV2::incRef(const QObject *link)
     } else {
         m_refs.append(nullptr);
     }
+    qDebug() << Q_FUNC_INFO << "\n    " << m_refs;
 }
 
 void GlobalReceiverV2::decRef(const QObject *link)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << link;
     if (m_refs.empty())
         return;
 
@@ -297,6 +303,7 @@ int GlobalReceiverV2::refCount(const QObject *link) const
 void GlobalReceiverV2::notify()
 {
     const QSet<const QObject *> objSet(m_refs.cbegin(), m_refs.cend());
+    qDebug() << Q_FUNC_INFO << "\n    " << this << objSet;
     Py_BEGIN_ALLOW_THREADS
     for (const QObject *o : objSet) {
         QMetaObject::disconnect(o, DESTROY_SIGNAL_ID, this, DESTROY_SLOT_ID);
@@ -322,6 +329,7 @@ const QMetaObject *GlobalReceiverV2::metaObject() const
 
 int GlobalReceiverV2::qt_metacall(QMetaObject::Call call, int id, void **args)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << call << id;
     Shiboken::GilState gil;
     Q_ASSERT(call == QMetaObject::InvokeMetaMethod);
     Q_ASSERT(id >= QObject::staticMetaObject.methodCount());
@@ -342,6 +350,7 @@ int GlobalReceiverV2::qt_metacall(QMetaObject::Call call, int id, void **args)
         if (m_refs.empty())
             return -1;
         auto obj = *reinterpret_cast<QObject **>(args[1]);
+        qDebug() << Q_FUNC_INFO << "\n    " << obj;
         incRef(); //keep the object live (safe ref)
         m_refs.removeAll(obj); // remove all refs to this object
         decRef(); //remove the safe ref
diff --git a/sources/pyside6/libpyside/pysidesignal.cpp b/sources/pyside6/libpyside/pysidesignal.cpp
index 78f4d2a89..14eecc179 100644
--- a/sources/pyside6/libpyside/pysidesignal.cpp
+++ b/sources/pyside6/libpyside/pysidesignal.cpp
@@ -41,7 +41,6 @@
 #include "pysidesignal.h"
 #include "pysidesignal_p.h"
 #include "pysidestaticstrings.h"
-#include "signalmanager.h"
 
 #include <shiboken.h>
 
diff --git a/sources/pyside6/libpyside/signalmanager.cpp b/sources/pyside6/libpyside/signalmanager.cpp
index f85a63b31..b23f4ba93 100644
--- a/sources/pyside6/libpyside/signalmanager.cpp
+++ b/sources/pyside6/libpyside/signalmanager.cpp
@@ -297,11 +297,13 @@ void SignalManager::setQmlMetaCallErrorHandler(QmlMetaCallErrorHandler handler)
 
 QObject *SignalManager::globalReceiver(QObject *sender, PyObject *callback)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << "\n    " << sender << callback;
     GlobalReceiverV2MapPtr globalReceivers = m_d->m_globalReceivers;
     GlobalReceiverKey key = GlobalReceiverV2::key(callback);
     GlobalReceiverV2 *gr = nullptr;
     auto it = globalReceivers->find(key);
     if (it == globalReceivers->end()) {
+        qDebug() << __FUNCTION__ << "end, creating new GlobalReceiverV2";
         gr = new GlobalReceiverV2(callback, globalReceivers);
         globalReceivers->insert(key, gr);
         if (sender) {
@@ -310,6 +312,7 @@ QObject *SignalManager::globalReceiver(QObject *sender, PyObject *callback)
         }
     } else {
         gr = it.value();
+        qDebug() << __FUNCTION__ << "accessing existing GlobalReceiverV2" << gr;
         if (sender)
             gr->incRef(sender);
     }
@@ -319,6 +322,7 @@ QObject *SignalManager::globalReceiver(QObject *sender, PyObject *callback)
 
 int SignalManager::countConnectionsWith(const QObject *object)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << "\n    " << object;
     int count = 0;
     for (GlobalReceiverV2Map::const_iterator it = m_d->m_globalReceivers->cbegin(), end = m_d->m_globalReceivers->cend(); it != end; ++it) {
         if (it.value()->refCount(object))
@@ -329,22 +333,26 @@ int SignalManager::countConnectionsWith(const QObject *object)
 
 void SignalManager::notifyGlobalReceiver(QObject *receiver)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << "\n    " << receiver;
     reinterpret_cast<GlobalReceiverV2 *>(receiver)->notify();
 }
 
 void SignalManager::releaseGlobalReceiver(const QObject *source, QObject *receiver)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << "\n    " << source << receiver;
     auto gr = reinterpret_cast<GlobalReceiverV2 *>(receiver);
     gr->decRef(source);
 }
 
 int SignalManager::globalReceiverSlotIndex(QObject *receiver, const char *signature) const
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << "\n    " << receiver << signature;
     return reinterpret_cast<GlobalReceiverV2 *>(receiver)->addSlot(signature);
 }
 
 bool SignalManager::emitSignal(QObject *source, const char *signal, PyObject *args)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << source << signal;
     if (!Signal::checkQtSignal(signal))
         return false;
     signal++;
@@ -448,6 +456,7 @@ int SignalManager::qt_metacall(QObject *object, QMetaObject::Call call, int id,
 
 int SignalManager::callPythonMetaMethod(const QMetaMethod &method, void **args, PyObject *pyMethod, bool isShortCuit)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << method.name();
     Q_ASSERT(pyMethod);
 
     Shiboken::GilState gil;
@@ -511,6 +520,7 @@ static MetaObjectBuilder *metaBuilderFromDict(PyObject *dict)
 
 int SignalManager::registerMetaMethodGetIndex(QObject *source, const char *signature, QMetaMethod::MethodType type)
 {
+    qDebug() << Q_FUNC_INFO << "\n    " << source << signature << type;
     if (!source) {
         qWarning("SignalManager::registerMetaMethodGetIndex(\"%s\") called with source=nullptr.",
                  signature);