From a9ae0522e0a54f6c473a3e5a9834c7744e246554 Mon Sep 17 00:00:00 2001
From: Rami Potinkara <rami.potinkara@qt.io>
Date: Sat, 18 Jun 2022 12:39:25 +0300
Subject: [PATCH] Android: Gradle Update to 7.4.2

Pick-to: 6.4
Fixes: QTBUG-103711
Change-Id: Ie9898abcac550a3dcd7b12badbf360243cafa831
---
 .../gradle/gradle/wrapper/gradle-wrapper.jar  | Bin 59821 -> 87373 bytes
 .../gradle/wrapper/gradle-wrapper.properties  |   2 +-
 src/3rdparty/gradle/qt_attribution.json       |   6 +++---
 src/android/templates/build.gradle            |   2 +-
 4 files changed, 5 insertions(+), 5 deletions(-)

diff --git a/src/3rdparty/gradle/gradle/wrapper/gradle-wrapper.jar b/src/3rdparty/gradle/gradle/wrapper/gradle-wrapper.jar
index 41d9927a4d4fb3f96a785543079b8df6723c946b..4a2b204de549f59ddea98faa1c17cf8044eb460f 100644
GIT binary patch
diff --git a/src/3rdparty/gradle/gradle/wrapper/gradle-wrapper.properties b/src/3rdparty/gradle/gradle/wrapper/gradle-wrapper.properties
index 41dfb87909..aa991fceae 100644
--- a/src/3rdparty/gradle/gradle/wrapper/gradle-wrapper.properties
+++ b/src/3rdparty/gradle/gradle/wrapper/gradle-wrapper.properties
@@ -1,5 +1,5 @@
 distributionBase=GRADLE_USER_HOME
 distributionPath=wrapper/dists
-distributionUrl=https\://services.gradle.org/distributions/gradle-7.4-bin.zip
+distributionUrl=https\://services.gradle.org/distributions/gradle-7.4.2-bin.zip
 zipStoreBase=GRADLE_USER_HOME
 zipStorePath=wrapper/dists
diff --git a/src/3rdparty/gradle/qt_attribution.json b/src/3rdparty/gradle/qt_attribution.json
index fda92d2592..4084e64611 100644
--- a/src/3rdparty/gradle/qt_attribution.json
+++ b/src/3rdparty/gradle/qt_attribution.json
@@ -4,11 +4,11 @@
     "QDocModule": "qtcore",
     "QtParts": ["tools"],
     "Homepage": "https://gradle.org",
-    "Version": "7.4.0",
-    "DownloadLocation": "https://github.com/gradle/gradle/releases/tag/v7.4.0",
+    "Version": "7.4.2",
+    "DownloadLocation": "https://github.com/gradle/gradle/releases/tag/v7.4.2",
     "QtUsage": "Needed to create Android packages",
     "License": "Apache License 2.0",
     "LicenseId": "Apache-2.0",
     "LicenseFile": "LICENSE",
-    "Copyright": "Copyright (C) 2021 Gradle Inc."
+    "Copyright": "Copyright (C) 2022 Gradle Inc."
 }
diff --git a/src/android/templates/build.gradle b/src/android/templates/build.gradle
index 4c711790f8..ccd588dbd7 100644
--- a/src/android/templates/build.gradle
+++ b/src/android/templates/build.gradle
@@ -5,7 +5,7 @@ buildscript {
     }
 
     dependencies {
-        classpath 'com.android.tools.build:gradle:7.0.2'
+        classpath 'com.android.tools.build:gradle:7.4.2'
     }
 }
 
-- 
2.25.1