diff --git a/examples/opengl/contextinfo/contextinfo.py b/examples/opengl/contextinfo/contextinfo.py
index f66d5a46f..742cb303d 100644
--- a/examples/opengl/contextinfo/contextinfo.py
+++ b/examples/opengl/contextinfo/contextinfo.py
@@ -27,6 +27,43 @@ except ImportError:
     message_box.exec()
     sys.exit(1)
 
+
+def formatReturnType(v):
+    t = type(v)
+    result = str(t)
+    if t == numpy.ndarray:
+        result += f", dtype={v.dtype}"
+    return result
+
+
+def printGetBooleanv(pname, desc, functions):
+    v = functions.glGetBooleanv(pname)
+    print("[bool]   Qt: ", desc, "=", v, ", ", formatReturnType(v))
+    v = GL.glGetBooleanv(pname)
+    print("         PyOpenGL: ", desc, "=", v, ", ", formatReturnType(v))
+
+
+def printGetDoublev(pname, desc, functions):
+    v = None # Not impl: functions.glGetDoublev(pname)
+    print("[double] Qt: ", desc, "=", v, ", ", formatReturnType(v))
+    v = GL.glGetDoublev(pname)
+    print("         PyOpenGL: ", desc, "=", v, ", ", formatReturnType(v))
+
+
+def printGetFloatv(pname, desc, functions):
+    v = functions.glGetFloatv(pname)
+    print("[float]  Qt: ", desc, "=", v, ", ", formatReturnType(v))
+    v = GL.glGetFloatv(pname)
+    print("         PyOpenGL: ", desc, "=", v, ", ", formatReturnType(v))
+
+
+def printGetIntegerv(pname, desc, functions):
+    v = functions.glGetIntegerv(pname)
+    print("[int]    Qt: ", desc, "=", v, ", ", formatReturnType(v))
+    v = GL.glGetIntegerv(pname)
+    print("         PyOpenGL: ", desc, "=", v, ", ", formatReturnType(v))
+
+
 vertex_shader_source_110 = dedent("""
     // version 110
     attribute highp vec4 posAttr;
@@ -207,6 +244,13 @@ class RenderWindow(QWindow):
         context_surface_format = print_surface_format(self.context.format())
         surface_format = print_surface_format(self.format())
 
+        printGetBooleanv(GL.GL_COLOR_LOGIC_OP, "GL_COLOR_LOGIC_OP", functions)
+        printGetBooleanv(GL.GL_COLOR_WRITEMASK, "GL_COLOR_WRITEMASK", functions)
+        printGetFloatv(GL.GL_COLOR_CLEAR_VALUE, "GL_COLOR_CLEAR_VALUE", functions)
+        printGetDoublev(GL.GL_COLOR_CLEAR_VALUE, "GL_COLOR_CLEAR_VALUE", functions)
+        printGetIntegerv(GL.GL_COLOR_CLEAR_VALUE, "GL_COLOR_CLEAR_VALUE", functions)
+        printGetIntegerv(GL.GL_MAX_LIGHTS, "GL_MAX_LIGHTS", functions)
+
         text = (f"Vendor: {gl_vendor}\n"
                 f"Renderer: {gl_renderer}\n"
                 f"Version: {gl_version}\n"
diff --git a/examples/opengl/textures/textures.py b/examples/opengl/textures/textures.py
index 79f7761a2..c0a547685 100644
--- a/examples/opengl/textures/textures.py
+++ b/examples/opengl/textures/textures.py
@@ -5,6 +5,7 @@
 """PySide6 port of the opengl/textures example from Qt v6.x showing the use
    of legacy OpenGL functions with QOpenGLVersionFunctionsFactory."""
 
+import numpy
 import sys
 from PySide6.QtCore import QPoint, QSize, Qt, QTimer, Signal
 from PySide6.QtGui import QColor, QImage, QSurfaceFormat
@@ -27,6 +28,49 @@ except ImportError:
 import textures_rc
 
 
+def formatReturnType(v):
+    t = type(v)
+    result = str(t)
+    if t == numpy.ndarray:
+        result += f", dtype={v.dtype}"
+    return result
+
+
+def printGetBooleanv(pname, desc, functions):
+    v = functions.glGetBooleanv(pname)
+    print("[bool]   Qt: ", desc, "=", v, ", ", formatReturnType(v))
+    v = GL.glGetBooleanv(pname)
+    print("         PyOpenGL: ", desc, "=", v, ", ", formatReturnType(v))
+
+
+def printGetDoublev(pname, desc, functions):
+    v = None # Not impl: functions.glGetDoublev(pname)
+    print("[double] Qt: ", desc, "=", v, ", ", formatReturnType(v))
+    v = GL.glGetDoublev(pname)
+    print("         PyOpenGL: ", desc, "=", v, ", ", formatReturnType(v))
+
+
+def printGetFloatv(pname, desc, functions):
+    v = functions.glGetFloatv(pname)
+    print("[float]  Qt: ", desc, "=", v, ", ", formatReturnType(v))
+    v = GL.glGetFloatv(pname)
+    print("         PyOpenGL: ", desc, "=", v, ", ", formatReturnType(v))
+
+
+def printGetIntegerv(pname, desc, functions):
+    v = functions.glGetIntegerv(pname)
+    print("[int]    Qt: ", desc, "=", v, ", ", formatReturnType(v))
+    v = GL.glGetIntegerv(pname)
+    print("         PyOpenGL: ", desc, "=", v, ", ", formatReturnType(v))
+
+
+def printGetIntegeri_v(pname, index, desc, functions):
+    v = functions.glGetIntegeri_v(pname, index)
+    print("indexed [int] Qt: ", desc, "[", index, "]=", v, ", ", formatReturnType(v))
+    v = GL.glGetIntegeri_v(pname, index)
+    print("              PyOpenGL: ", desc,  "[", index, "]=", v, ", ", formatReturnType(v))
+
+
 class GLWidget(QOpenGLWidget):
     sharedObject = 0
     refCount = 0
@@ -80,8 +124,18 @@ class GLWidget(QOpenGLWidget):
         profile.setVersion(3, 2)
         profile.setProfile(QSurfaceFormat.CompatibilityProfile)
         self.funcs = QOpenGLVersionFunctionsFactory.get(profile)
+        print(self.funcs)
         self.funcs.initializeOpenGLFunctions()
 
+        printGetBooleanv(GL.GL_COLOR_LOGIC_OP, "GL_COLOR_LOGIC_OP", self.funcs)
+        printGetBooleanv(GL.GL_COLOR_WRITEMASK, "GL_COLOR_WRITEMASK", self.funcs)
+        printGetFloatv(GL.GL_COLOR_CLEAR_VALUE, "GL_COLOR_CLEAR_VALUE", self.funcs)
+        printGetDoublev(GL.GL_COLOR_CLEAR_VALUE, "GL_COLOR_CLEAR_VALUE", self.funcs)
+        printGetIntegerv(GL.GL_COLOR_CLEAR_VALUE, "GL_COLOR_CLEAR_VALUE", self.funcs)
+        printGetIntegerv(GL.GL_MAX_LIGHTS, "GL_MAX_LIGHTS", self.funcs)
+
+        printGetIntegeri_v(GL.GL_SHADER_STORAGE_BUFFER_SIZE, 0, "GL_SHADER_STORAGE_BUFFER_SIZE", self.funcs)
+
         if not GLWidget.sharedObject:
             self.textures = []
             for i in range(6):